#ifndef FLUTTER_PLUGIN_LYCAN_PAY_PLUGIN_H_
#define FLUTTER_PLUGIN_LYCAN_PAY_PLUGIN_H_

#include <flutter/method_channel.h>
#include <flutter/plugin_registrar_windows.h>

#include <memory>

namespace lycan_pay {

class LycanPayPlugin : public flutter::Plugin {
 public:
  static void RegisterWithRegistrar(flutter::PluginRegistrarWindows *registrar);

  LycanPayPlugin();

  virtual ~LycanPayPlugin();

  // Disallow copy and assign.
  LycanPayPlugin(const LycanPayPlugin&) = delete;
  LycanPayPlugin& operator=(const LycanPayPlugin&) = delete;

 private:
  // Called when a method is called on this plugin's channel from Dart.
  void HandleMethodCall(
      const flutter::MethodCall<flutter::EncodableValue> &method_call,
      std::unique_ptr<flutter::MethodResult<flutter::EncodableValue>> result);
};

}  // namespace lycan_pay

#endif  // FLUTTER_PLUGIN_LYCAN_PAY_PLUGIN_H_
