import 'package:flutter_test/flutter_test.dart';
import 'package:lycan_pay/lycan_pay.dart';
import 'package:lycan_pay/lycan_pay_platform_interface.dart';
import 'package:lycan_pay/lycan_pay_method_channel.dart';
import 'package:plugin_platform_interface/plugin_platform_interface.dart';
import 'package:flutter/material.dart';

class MockLycanPayPlatform 
    with MockPlatformInterfaceMixin
    implements LycanPayPlatform {

  @override
  Future<String?> getPlatformVersion() => Future.value('42');
}

void main() {
  final LycanPayPlatform initialPlatform = LycanPayPlatform.instance;

  test('$MethodChannelLycanPay is the default instance', () {
    expect(initialPlatform, isInstanceOf<MethodChannelLycanPay>());
  });

  test('getPlatformVersion', () async {

 TextEditingController controller1 = TextEditingController();
 TextEditingController controller2 = TextEditingController();
 TextEditingController controller3 = TextEditingController();
 TextEditingController controller4= TextEditingController();
 TextEditingController controller5= TextEditingController();

    LycanPay lycanPayPlugin =  LycanPay(
      controller1:controller1,
      controller2: controller2,
      controller3: controller3,
      controller4: controller4,
      controller5: controller5,);

    MockLycanPayPlatform fakePlatform = MockLycanPayPlatform();

    LycanPayPlatform.instance = fakePlatform;
  
  });
}
